'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty = require('babel-runtime/core-js/reflect/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

exports.strictProperty = strictProperty;
exports.symbolProperties = symbolProperties;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var strictAttributes = { enumerable: false,
  configurable: false
};

/** Defines a property on an object with strict privatish defaults. */
function strictProperty(target, propertyKey, attributes) {
  var flags = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  var result = (0, _defineProperty2.default)(target, propertyKey, (0, _extends3.default)({}, strictAttributes, attributes));
  if (flags.pipe && target !== 'undefined') return target[propertyKey];
  return result;
}

/** Defines a property on an object with strict privatish defaults. */
function symbolProperties(target, symbols) {
  var flags = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  return (0, _entries2.default)(symbols).reduce(function (_target, _ref) {
    var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
        symbolKey = _ref2[0],
        value = _ref2[1];

    var result = define.strictProperty(_target, symbolKey, { value: value }, { pipe: true });
    if (flags.throws && !result) throw new TypeError('Could not assign strict property to target type "' + (typeof _target === 'undefined' ? 'undefined' : (0, _typeof3.default)(_target)) + '"');
    return _target;
  }, target);
}