'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.reflect = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends5 = require('babel-runtime/helpers/extends');

var _extends6 = _interopRequireDefault(_extends5);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _symbols = require('./symbols');

var symbols = _interopRequireWildcard(_symbols);

var _define = require('./define');

var define = _interopRequireWildcard(_define);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noop = function noop() {};

var symbolRegistry = { type: symbols.type,
  rootType: symbols.rootType,
  genericType: symbols.genericType,
  genericTypes: symbols.genericTypes,
  instanceType: symbols.instanceType
};
var symbolEntries = (0, _entries2.default)(symbolRegistry);

var reflect = exports.reflect = (0, _freeze2.default)((0, _assign2.default)(function (x) {
  return symbolEntries.reduce(function (reduction, _ref) {
    var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
        name = _ref2[0],
        symbol = _ref2[1];

    var value = x[symbol];
    if (typeof value === 'undefined') return reduction;
    return (0, _extends6.default)({}, reduction, (0, _defineProperty3.default)({}, name, symbol));
  }, {});
}, symbolEntries.reduce(function (reduction, _ref3) {
  var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
      name = _ref4[0],
      symbol = _ref4[1];

  return (0, _extends6.default)({}, reduction, (0, _defineProperty3.default)({}, name, function (x) {
    return x[symbol];
  }));
}, {})));

/** Factory that imbues objects with symbol type information and type utils. */
function metaTypes(rootTypeName) {
  var _typedProps;

  for (var _len = arguments.length, _genericTypeNames = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    _genericTypeNames[_key - 1] = arguments[_key];
  }

  var _genericTypeName = _genericTypeNames.length > 0 ? _genericTypeNames.join(',') : noop();
  var typeName = '' + rootTypeName + (_genericTypeName ? '<' + _genericTypeName + '>' : '');

  var typedProps = (_typedProps = {}, (0, _defineProperty3.default)(_typedProps, symbols.type, typeName), (0, _defineProperty3.default)(_typedProps, symbols.rootType, typeName), (0, _defineProperty3.default)(_typedProps, symbols.genericType, _genericTypeName), (0, _defineProperty3.default)(_typedProps, symbols.genericTypes, _genericTypeNames), _typedProps);

  var namedProps = reflect(typedProps);

  var flags = (0, _freeze2.default)({ get generic() {
      return typeof _genericTypeName !== 'undefined';
    }
  });

  var iterableHas = function iterableHas(testName) {
    return { genericTypes: function (_genericTypes) {
        function genericTypes() {
          return _genericTypes.apply(this, arguments);
        }

        genericTypes.toString = function () {
          return _genericTypes.toString();
        };

        return genericTypes;
      }(function () {
        for (var _len2 = arguments.length, x = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          x[_key2] = arguments[_key2];
        }

        return x[testName](function (y) {
          return genericTypes.includes(y);
        });
      }),
      genericTypeNames: function genericTypeNames() {
        for (var _len3 = arguments.length, x = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          x[_key3] = arguments[_key3];
        }

        return x[testName](function (y) {
          return _genericTypeNames.includes(y);
        });
      }
    };
  };

  var is = (0, _freeze2.default)({ type: function type(x) {
      return x[symbols.type] === typeName;
    },
    rootType: function rootType(x) {
      return x[symbols.rootType] === rootTypeName;
    },
    genericType: function (_genericType) {
      function genericType(_x) {
        return _genericType.apply(this, arguments);
      }

      genericType.toString = function () {
        return _genericType.toString();
      };

      return genericType;
    }(function (x) {
      return x[symbols.genericType] === genericType;
    }),
    genericTypeName: function genericTypeName(x) {
      return x === _genericTypeName;
    }
  });

  var has = (0, _freeze2.default)({ all: iterableHas('every'),
    any: iterableHas('some')
  });

  var utils = (0, _freeze2.default)((0, _extends6.default)({ typedProps: typedProps
  }, namedProps, { flags: flags,
    reflect: reflect,
    is: is,
    has: has,
    imbue: function imbue(target) {
      return define.symbolProperties(target, typedProps);
    }
  }));

  var instance = function instance() {
    for (var _len4 = arguments.length, path = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      path[_key4] = arguments[_key4];
    }

    return (0, _extends6.default)({}, typedProps, (0, _defineProperty3.default)({}, symbols.instanceType, path.reduce(function (reduction, x) {
      return reduction + '#' + x;
    }, 'instance')));
  };

  return (0, _freeze2.default)((0, _assign2.default)(instance, utils));
}
exports.default = metaTypes;