'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

exports.statsFactory = statsFactory;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function statsFactory() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$collapsed = _ref.collapsed,
      collapsed = _ref$collapsed === undefined ? true : _ref$collapsed;

  return function (title, stats) {
    if (console.group && console.table) {
      try {
        console[collapsed ? 'groupCollapsed' : 'group'](title);
        if (stats instanceof Error) console.error(stats);else console.table(Array.isArray(stats) ? stats : (0, _entries2.default)(stats));
      } catch (err) {
        console.error(err);
      } finally {
        console.groupEnd();
      }
    } else {
      console.info(title + '\n' + (0, _stringify2.default)(stats, null, 2));
    }
  };
}

/** Prints stats of a target object to console.  */
exports.default = statsFactory();